import { RevertableEvent } from "@skeldjs/events";
import { RepairSystemMessage } from "@skeldjs/protocol";
import { Hostable } from "../../Hostable";
import { PlayerData } from "../../PlayerData";
import { MedScanSystem } from "../../systems";
import { ProtocolEvent } from "../ProtocolEvent";
import { RoomEvent } from "../RoomEvent";
import { MedScanEvent } from "./MedScanEvent";
/**
 * Emitted when a player leaves the queue for a med scan.
 */
export declare class MedScanLeaveQueueEvent<RoomType extends Hostable = Hostable> extends RevertableEvent implements RoomEvent, MedScanEvent, ProtocolEvent {
    readonly room: RoomType;
    readonly medscan: MedScanSystem<RoomType>;
    readonly message: RepairSystemMessage | undefined;
    /**
     * The player that left the queue.
     */
    readonly player: PlayerData<RoomType>;
    static eventName: "medscan.leavequeue";
    eventName: "medscan.leavequeue";
    private _alteredPlayer;
    constructor(room: RoomType, medscan: MedScanSystem<RoomType>, message: RepairSystemMessage | undefined, 
    /**
     * The player that left the queue.
     */
    player: PlayerData<RoomType>);
    /**
     * The alternate player that will leave the queue instead, if changed.
     */
    get alteredPlayer(): PlayerData<RoomType>;
    /**
     * Change the player that left the queue.
     * @param player The player that left the queue.
     */
    setPlayer(player: PlayerData<RoomType>): void;
}
